## seqan2 2.3.1+dfsg

=== apps/alf/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/alf/CMakeLists.txt
#
# CMakeLists.txt file for ALF.
# ===========================================================================

cmake_minimum_required (VERSION 3.0.0)
project (seqan_apps_alf CXX)
message (STATUS "Configuring apps/alf")

set (SEQAN_APP_VERSION "1.1.8")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Update the list of file names below if you add source files to your application.
add_executable (alf alf.cpp)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (alf ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (alf)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install alf in ${PREFIX}/bin directory
install (TARGETS alf
         DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/alf for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/small.fasta
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

#seqan_add_app_test (alf)

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------
	
# Include executable seqan_tcoffee in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} alf CACHE INTERNAL "")

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:alf")
  set (CPACK_PACKAGE_NAME "alf")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "alf - Alignment Free Sequence Comparison")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (alf "alf")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:alf")

=== apps/dfi/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/dfi/CMakeLists.txt
#
# CMakeLists.txt file for DFI.
# ===========================================================================

cmake_minimum_required (VERSION 3.0.0)
project (seqan_apps_dfi CXX)
message (STATUS "Configuring apps/dfi")

set (SEQAN_APP_VERSION "2.1.8")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Update the list of file names below if you add source files to your application.
add_executable (dfi dfi.cpp)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (dfi ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (dfi)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install dfi in ${PREFIX}/bin directory
install (TARGETS dfi
         DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/dfi for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/fasta1.fa
               example/fasta2.fa
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

seqan_add_app_test (dfi)

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include executable razers in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} dfi CACHE INTERNAL "")

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:dfi")
  set (CPACK_PACKAGE_NAME "dfi")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "DFI - Fast String Mining of Multiple Databases under Frequency Constraints")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "David Weese <david.weese@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (dfi "DFI")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:dfi")

=== apps/fiona/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: apps/fiona/CMakeLists.txt
#
# CMakeLists.txt file for fiona.
# ===========================================================================

cmake_minimum_required (VERSION 3.0.0)
project (seqan_apps_fiona CXX)
message (STATUS "Configuring apps/fiona")

set (SEQAN_APP_VERSION "0.2.8")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (OpenMP)
    find_package (ZLIB)
    find_package (Boost)
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# Stop here if we cannot find Boost or OpenMP.
if (NOT Boost_FOUND OR NOT OPENMP_FOUND)
    message (STATUS "  Boost or OpenMP not found, not building fiona.")
    return ()
endif ()

if (NOT CMAKE_SIZEOF_VOID_P EQUAL 8)
    message (STATUS "  Not building fiona on 32bit architectures.")
    return ()
endif()

# all windows compilers are currently broken with Fiona (in different ways)
if (MSVC)
    message (STATUS "  Not building fiona under Visual Studio.")
    return ()
endif()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})
include_directories (SYSTEM ${Boost_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})
#add_definitions("-DQGRAM_LENGTH=5")

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Update the list of file names below if you add source files to your application.
add_executable (compute_gain compute_gain.cpp)
add_executable (fiona fiona.cpp)
add_executable (fiona_illumina fiona.cpp)

set_target_properties (fiona_illumina PROPERTIES COMPILE_DEFINITIONS "FIONA_ILLUMINA")

# Add dependencies found by find_package (SeqAn).
target_link_libraries (compute_gain ${SEQAN_LIBRARIES})
target_link_libraries (fiona ${SEQAN_LIBRARIES})
target_link_libraries (fiona_illumina ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (fiona)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install fiona in ${PREFIX}/bin directory
install (TARGETS fiona compute_gain DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/fiona for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/reads.fa
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

seqan_add_app_test (fiona)

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include executable fiona in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} fiona fiona_illumina compute_gain CACHE INTERNAL "")

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:fiona")
  set (CPACK_PACKAGE_NAME "fiona")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "fiona")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "David Weese <david.weese@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (fiona "fiona")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:fiona")

=== apps/fx_tools/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/fx_tools/CMakeLists.txt
#
# CMakeLists.txt file for fx_tools.
# ===========================================================================

cmake_minimum_required (VERSION 3.0.0)
project (seqan_apps_fx_tools CXX)
message (STATUS "Configuring apps/fx_tools")

set (SEQAN_APP_VERSION "0.2.8")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Setup SeqAn requirements.
include_directories (${SEQAN_INCLUDE_DIRS})
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# Computation of coverage and C+G content from genome and mapping.
add_executable (fx_bam_coverage fx_bam_coverage.cpp)
target_link_libraries (fx_bam_coverage ${SEQAN_LIBRARIES})

# Computation of statistics on FASTQ files.
add_executable (fx_fastq_stats fx_fastq_stats.cpp)
target_link_libraries (fx_fastq_stats ${SEQAN_LIBRARIES})

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (fx_tools)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install fx_tools in ${PREFIX}/bin directory
install (TARGETS fx_bam_coverage
         DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/fx_tools for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
#install (FILES example/fasta1.fa
#               example/fasta2.fa
#         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

#seqan_add_app_test (fx_tools)

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include executable razers in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} fx_fastq_stats fx_bam_coverage CACHE INTERNAL "")

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:fx_tools")
  set (CPACK_PACKAGE_NAME "fx_tools")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "fx_tools")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")

  seqan_configure_cpack_app (fx_tools "fx_tools")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:fx_tools")

=== apps/insegt/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/insegt/CMakeLists.txt
#
# CMakeLists.txt file for insegt.
# ===========================================================================

cmake_minimum_required (VERSION 3.0.0)
project (seqan_apps_insegt CXX)
message (STATUS "Configuring apps/insegt")

set (SEQAN_APP_VERSION "1.1.8")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Update the list of file names below if you add source files to your application.
add_executable (insegt
                insegt.cpp
                base.h
                create_gff.h
                fusion.h
                overlap_module.h)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (insegt ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (insegt)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install insegt in ${PREFIX}/bin directory
install (TARGETS insegt
         DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/insegt for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/annoOutput.gff
               example/annotations.gff
               example/readOutput.gff
               example/tupleOutput.gff
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

# Add app tests if Python interpreter could be found.
if(PYTHONINTERP_FOUND)
  add_test(NAME app_test_insegt COMMAND ${PYTHON_EXECUTABLE}
    ${CMAKE_CURRENT_SOURCE_DIR}/tests/run_tests.py ${CMAKE_SOURCE_DIR}
    ${CMAKE_BINARY_DIR})
endif(PYTHONINTERP_FOUND)

seqan_add_app_test (insegt)

# ---------------------------------------------------------------------------- 
# Setup Common Tool Description for Generic Workflow Nodes 
# ---------------------------------------------------------------------------- 
 
# Include executable razers in CTD structure. 
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} insegt CACHE INTERNAL "") 

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:insegt")
  set (CPACK_PACKAGE_NAME "insegt")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "insegt - Alignment Free Sequence Comparison")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (insegt "insegt")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:insegt")

=== apps/mason2/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /mason2/CMakeLists.txt
#
# CMakeLists.txt file for mason2.
# ===========================================================================

cmake_minimum_required (VERSION 3.0.0)
project (seqan_apps_mason2 CXX)
message (STATUS "Configuring apps/mason2")

set (SEQAN_APP_VERSION "2.0.7")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (OpenMP)
    find_package (ZLIB)
    find_package (SeqAn CONFIG REQUIRED)
endif ()

if (NOT ZLIB_FOUND)
  message (STATUS "  ZLIB not found: MASON2 will not be built.")
  return ()
endif (NOT ZLIB_FOUND)

# Enable C++11 in GCC and/or CLANG.
#if (CMAKE_COMPILER_IS_GNUCXX OR COMPILER_IS_CLANG)
#    add_definitions ("-std=c++0x")
#endif (CMAKE_COMPILER_IS_GNUCXX OR COMPILER_IS_CLANG)

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# We define a library for the reusable parts of Mason.
add_library (mason_sim
             external_split_merge.h
             external_split_merge.cpp
             fragment_generation.h
             genomic_variants.h
             genomic_variants.cpp
             individual_genome.h
             mason_options.cpp
             mason_options.h
             mason_types.h
             methylation_levels.cpp
             methylation_levels.h
             omp_wrapper.h
             sequencing.h
             simulate_454.cpp
             simulate_base.cpp
             simulate_genome.cpp
             simulate_genome.h
             simulate_illumina.cpp
             simulate_sanger.cpp
             variation_size_tsv.h
             vcf_materialization.cpp
             vcf_materialization.h)
target_link_libraries (mason_sim ${SEQAN_LIBRARIES})


# Simulate random genomes.
add_executable (mason_genome mason_genome.cpp)

# Simulate methylation levels for gnome.
add_executable (mason_methylation mason_methylation.cpp)

# Simulate sequencing of fragments.
add_executable (mason_frag_sequencing mason_frag_sequencing.cpp)

# Simulation of structural variants into FASTA sequences.
add_executable (mason_variator mason_variator.cpp)

# The materializer reads in FASTA and VCF and writes out FASTA.
add_executable (mason_materializer mason_materializer.cpp)

# The end-to-end read simulator includes materialization and fragment sampling.
add_executable (mason_simulator mason_simulator.cpp)

# Simulation splicing given a reference, GFF/GTF file, and possibly VCF for variants.
add_executable (mason_splicing mason_splicing.cpp)

# Tests for some of the library functionality.
add_executable (mason_tests mason_tests.cpp)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (mason_frag_sequencing ${SEQAN_LIBRARIES} mason_sim)
target_link_libraries (mason_genome ${SEQAN_LIBRARIES} mason_sim)
target_link_libraries (mason_materializer ${SEQAN_LIBRARIES} mason_sim)
target_link_libraries (mason_methylation ${SEQAN_LIBRARIES} mason_sim)
target_link_libraries (mason_simulator ${SEQAN_LIBRARIES} mason_sim)
target_link_libraries (mason_splicing ${SEQAN_LIBRARIES} mason_sim)
target_link_libraries (mason_tests ${SEQAN_LIBRARIES} mason_sim)
target_link_libraries (mason_variator ${SEQAN_LIBRARIES} mason_sim)

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include mason executables in CTD structure.
set (SEQAN_CTD_EXECUTABLES
    ${SEQAN_CTD_EXECUTABLES}
    mason_genome
    mason_frag_sequencing
    mason_variator
    mason_materializer
    mason_simulator
    CACHE INTERNAL "")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (mason2)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install Mason binaries in ${PREFIX}/bin directory
install (TARGETS mason_frag_sequencing
                 mason_genome
                 mason_materializer
                 mason_methylation
                 mason_simulator
                 mason_splicing
                 mason_variator
         DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/mason2 for SeqAn release builds.
install (FILES LICENSE
               README
               README.mason_frag_sequencing
               README.mason_genome
               README.mason_materializer
               README.mason_methylation
               README.mason_simulator
               README.mason_splicing
               README.mason_variator
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/adeno_virus.fa
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

seqan_add_app_test (mason2)

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:mason2")
  set (CPACK_PACKAGE_NAME "mason2")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "Versatile package for the simulation of nucleic sequence.")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")

  seqan_configure_cpack_app (mason2 "mason2")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:mason2")

=== apps/micro_razers/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/micro_razers/CMakeLists.txt
#
# CMakeLists.txt file for MicroRazerS.
# ===========================================================================

cmake_minimum_required (VERSION 3.0.0)
project (seqan_apps_micro_razers CXX)
message (STATUS "Configuring apps/micro_razers")

set (SEQAN_APP_VERSION "1.0.9")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Update the list of file names below if you add source files to your application.
add_executable (micro_razers
               micro_razers.cpp
               outputFormat.h
               ../razers/paramChooser.h
               ../razers/param_tabs.h
               ../razers/param_tabs.cpp
               ../razers/param_tabs.inc)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (micro_razers ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (micro_razers)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install micro_razers in ${PREFIX}/bin directory
install (TARGETS micro_razers
         DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/micro_razers for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/genome.fa
               example/reads.fa
               example/reads.fa.result
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

seqan_add_app_test (micro_razers)

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:micro_razers")
  set (CPACK_PACKAGE_NAME "micro_razers")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "MicroRazerS - Read Mapping With Controllable Sensitivity")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "David Weese <david.weese@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (micro_razers "MicroRazerS")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:micro_razers")

=== apps/ngs_roi/CMakeLists.txt ===
# ===========================================================================
#                  NGS: Regions of Interest Analysis
# ===========================================================================
# File: /sandbox/jagla/apps/ngs_roi/CMakeLists.txt
#
# CMakeLists.txt file for ngs_roi.
# ===========================================================================

cmake_minimum_required (VERSION 3.0.0)
project (seqan_apps_ngs_roi CXX)
message (STATUS "Configuring apps/ngs_roi")

set (SEQAN_APP_VERSION "0.2.10")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.

if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (ZLIB)
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# Update the list of file names below if you add source files to your application.
add_executable (roi_plot_thumbnails roi_plot_thumbnails.cpp png_canvas.h)
target_link_libraries (roi_plot_thumbnails ${SEQAN_LIBRARIES})

# bam2roi converts BAM file into ROI files.
add_executable (bam2roi bam2roi.cpp roi_builder.h roi_builder.cpp record_ext.h)
target_link_libraries (bam2roi ${SEQAN_LIBRARIES})

# roi_feature_projection allows the projection of ROIs to features (BED/GFF
# intervals or GFF exons).
add_executable (roi_feature_projection
                roi_feature_projection.cpp
                project_spliced.cpp
                project_spliced.h
                project_interval.cpp
                project_interval.h)
target_link_libraries (roi_feature_projection ${SEQAN_LIBRARIES})

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (ngs_roi)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install binaries into ${PREFIX}/bin directory.
install (TARGETS bam2roi
                 roi_feature_projection
                 roi_plot_thumbnails
         DESTINATION bin)

# Install helper scripts into ${PREFIX}/bin directory.
install (FILES # Scripts for sorting.
                 tool_shed/bed_sort.sh
                 tool_shed/gff_sort.sh
                 tool_shed/roi_sort.sh
                 # PDF plot script helper.
                 tool_shed/roi_plot_9.sh
                 tool_shed/plot.awk
                 tool_shed/ps2pswLinks.gawk
         DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/ngs_roi for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})

# Example files.
install (FILES example/dmel.bed
               example/dmel.gtf
               example/example.bam
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# R package for Linux and Mac.
install (FILES R/ngsroi_0.1.tar.gz
               R/ngsroi_0.1.zip
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/R)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

seqan_add_app_test (ngs_roi)

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:ngs_roi")
  set (CPACK_PACKAGE_NAME "ngs_roi")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "ngs_roi")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Bernd Jagla <bernd.jagla@pasteur.fr>")
  set (CPACK_PACKAGE_VENDOR "Bernd Jagla <bernd.jagla@pasteur.fr>")

  seqan_configure_cpack_app (ngs_roi "ngs_roi")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:ngs_roi")

=== apps/pair_align/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/pair_align/CMakeLists.txt
#
# CMakeLists.txt file for pair_align.
# ===========================================================================

cmake_minimum_required (VERSION 3.0.0)
project (seqan_apps_pair_align CXX)
message (STATUS "Configuring apps/pair_align")

set (SEQAN_APP_VERSION "1.3.6")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# Update the list of file names below if you add source files to your application.
add_executable (pair_align pair_align.cpp)

#Before linking create static library for pair_align
# Include lib folder to build the static library pair_align_lib.
add_subdirectory(lib)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (pair_align pair_align_lib ${SEQAN_LIBRARIES})

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (pair_align)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install pair_align in ${PREFIX}/bin directory
install (TARGETS pair_align
         DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/pair_align for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

seqan_add_app_test (pair_align)

# ----------------------------------------------------------------------------
# Setup Command Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Currently, pair_align uses a lot of memory to compile so we do not add it
# to the list of programs to build for workflow engines.

#Include executable pair_align in CTD structure.
#set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} pair_align CACHE INTERNAL "")

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:pair_align")
  set (CPACK_PACKAGE_NAME "pair_align")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "pair_align - Pairwise Sequence Alignment")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (pair_align "pair_align")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:pair_align")

=== apps/param_chooser/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/param_chooser/CMakeLists.txt
#
# CMakeLists.txt file for param_chooser.
# ===========================================================================

cmake_minimum_required (VERSION 3.0.0)
project (seqan_apps_param_chooser CXX)
message (STATUS "Configuring apps/param_chooser")

set (SEQAN_APP_VERSION "0.0.7")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Update the list of file names below if you add source files to your application.
add_executable (param_chooser param_chooser.cpp)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (param_chooser ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# Add binary for tests.
add_executable (test_funcs_param_chooser test_param_chooser.cpp)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (test_funcs_param_chooser ${SEQAN_LIBRARIES})

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (param_chooser)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install param_chooser in ${PREFIX}/bin directory
install (TARGETS param_chooser
         DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/param_chooser for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
#install (FILES
#         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

# Unit tests for the alignment free tests.
add_test (NAME test_test_funcs_param_chooser COMMAND $<TARGET_FILE:test_funcs_param_chooser>)

#seqan_add_app_test (param_chooser)

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:param_chooser")
  set (CPACK_PACKAGE_NAME "param_chooser")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "param_chooser - Parameter Choice for RazerS")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (param_chooser "param_chooser")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:param_chooser")

=== apps/rabema/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/rabema/CMakeLists.txt
#
# CMakeLists.txt file for Rabema.
# ===========================================================================

cmake_minimum_required (VERSION 3.0.0)
project (seqan_apps_rabema CXX)
message (STATUS "Configuring apps/rabema")

set (SEQAN_APP_VERSION "1.2.8")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (ZLIB)
    find_package (SeqAn CONFIG REQUIRED)
endif ()

if (NOT ZLIB_FOUND)
  message (STATUS "  ZLIB not found: RABEMA will not be built.")
  return ()
endif (NOT ZLIB_FOUND)

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Preparation of SAM files, i.e. filling SEQ field of each record.
add_executable (rabema_prepare_sam prepare_sam.cpp sorting.h)
target_link_libraries (rabema_prepare_sam ${SEQAN_LIBRARIES})

# Building of GSI file from "perfect" SAM file and reference sequence.
add_executable (rabema_build_gold_standard
               rabema_build_gold_standard.cpp
               curve_smoothing.h
               find_hamming_simple_ext.h
               find_myers_ukkonen_ext.h
               find_myers_ukkonen_reads.h
               io_gsi.h
               rabema_stats.h
               ref_id_mapping.h
               sorting.h)
target_link_libraries (rabema_build_gold_standard ${SEQAN_LIBRARIES})

# Comparison of arbitrary read mapper SAM against GSI file.
add_executable (rabema_evaluate rabema_evaluate.cpp
               curve_smoothing.h
               find_hamming_simple_ext.h
               find_myers_ukkonen_ext.h
               find_myers_ukkonen_reads.h
               io_gsi.h
               rabema_stats.h
               ref_id_mapping.h
               sorting.h)
target_link_libraries (rabema_evaluate ${SEQAN_LIBRARIES})

# Small tool for helping in debugging.
add_executable (rabema_do_search do_search.cpp find_myers_ukkonen_ext.h)
target_link_libraries (rabema_do_search ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (rabema)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install rabema programs in ${PREFIX}/bin directory
install (TARGETS rabema_prepare_sam
                 rabema_build_gold_standard
                 rabema_evaluate
         DESTINATION bin)

# Install rabema in /bin directory
install (TARGETS rabema_prepare_sam rabema_build_gold_standard rabema_evaluate
        DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/pair_align for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

seqan_add_app_test (rabema)

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include executable razers in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} rabema_prepare_sam rabema_build_gold_standard rabema_evaluate CACHE INTERNAL "")

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:rabema")
    set (CPACK_PACKAGE_NAME "rabema")
    set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "Rabema - Read Alignment Benchmark")
    set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")
    set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

    seqan_configure_cpack_app (rabema "Rabema")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:rabema")

=== apps/razers/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/razers/CMakeLists.txt
#
# CMakeLists.txt file for RazerS.
# ===========================================================================

cmake_minimum_required (VERSION 3.0.0)
project (seqan_apps_razers CXX)
message (STATUS "Configuring apps/razers")

set (SEQAN_APP_VERSION "1.5.6")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Update the list of file names below if you add source files to your application.
add_executable (razers razers.cpp
                      razers.h
                      param_tabs.h
                      param_tabs.cpp
                      param_tabs.inc
                      outputFormat.h
                      paramChooser.h
                      razers_matepairs.h
                      razers_spliced.h
                      readSimulator.h
                      param_tabs.h)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (razers ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (razers)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install razers in ${PREFIX}/bin directory
install (TARGETS razers
         DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/razers for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/genome.fa
               example/reads.fa
               example/reads2.fa
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

seqan_add_app_test (razers)

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include executable razers in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} razers CACHE INTERNAL "")

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:razers")
  set (CPACK_PACKAGE_NAME "razers")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "RazerS - Read Mapping With Controllable Sensitivity")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "David Weese <david.weese@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (razers "RazerS")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:razers")

=== debian/changelog ===
seqan2 (2.3.1+dfsg-5ubuntu2) artful; urgency=medium

  * Fix missing exec bit on debian/generate_manpages, somehow dropped in
    merge.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 31 Aug 2017 00:58:56 -0700

seqan2 (2.3.1+dfsg-5ubuntu1) artful; urgency=medium

  * Merge from Debian unstable.  Remaining changes:
    - Add amd64 and arm64 to the list of low-memory architectures
    - Enable build on armhf

 -- Bhavani Shankar <bhavi@ubuntu.com>  Wed, 05 Jul 2017 17:34:14 +0530

seqan2 (2.3.1+dfsg-5) unstable; urgency=medium

  * Team upload.
  * Make build reproducible.
    Thanks to Chris Lamb for the patch.
    Closes: #862484

 -- Sascha Steinbiss <satta@debian.org>  Tue, 04 Jul 2017 23:24:52 +0200

seqan2 (2.3.1+dfsg-4ubuntu1) artful; urgency=medium

  * Merge from Debian unstable.  Remaining changes:
    - Add amd64 and arm64 to the list of low-memory architectures
    - Enable build on armhf
    - Add patch from Chris Lamb to make the build reproducible.

 -- Bhavani Shankar <bhavi@ubuntu.com>  Sun, 04 Jun 2017 10:16:12 +0530

seqan2 (2.3.1+dfsg-4) unstable; urgency=medium

  * Fix FTBFS when built with dpkg-buildpackage -A (thanks for the patch to
    Santiago Vila <sanvila@debian.org>)
    Closes: #864026

 -- Andreas Tille <tille@debian.org>  Sat, 03 Jun 2017 16:15:29 +0200

seqan2 (2.3.1+dfsg-3.1ubuntu1) artful; urgency=medium

  * Merge from Debian unstable.  Remaining changes:
    - Add amd64 and arm64 to the list of low-memory architectures
    - Enable build on armhf
    - Add patch from Chris Lamb to make the build reproducible.

 -- Bhavani Shankar <bhavi@ubuntu.com>  Wed, 31 May 2017 10:43:50 +0530

seqan2 (2.3.1+dfsg-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix broken /usr/bin/splazers symlink on 32-bit architectures.
    (Closes: #863669)

 -- Chris Lamb <lamby@debian.org>  Mon, 29 May 2017 22:56:39 +0100

seqan2 (2.3.1+dfsg-3ubuntu1) zesty; urgency=medium

  * Add amd64 and arm64 to the list of low-memory architectures
  * Enable build on armhf

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 20 Jan 2017 15:37:06 +0200

seqan2 (2.3.1+dfsg-3) unstable; urgency=medium

  * add patch FWDs, set HOME to fix manpages

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sun, 15 Jan 2017 01:34:05 -0800

seqan2 (2.3.1+dfsg-2) unstable; urgency=medium

  * Remove archs with failing builds: armhf mips mipsel
  * Set SEQAN_REVISION to 'tarball' so that ccache isn't poisened by changes
    to debian/
  * Release to unstable

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sat, 14 Jan 2017 00:23:26 -0800

seqan2 (2.3.1+dfsg-1) experimental; urgency=medium

  * Try to save more memory on kfreebsd-*
  * Fix parallel build disabling to not produce warnings
  * New upstream release, three incorporated patched removed

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 13 Jan 2017 05:36:28 -0800

seqan2 (2.3.0~1.20161019~af07bc1+dfsg-4) experimental; urgency=medium

  * Try out -O3 for many architectures as that is upstream's default.
  * Skip unneeded build for -indep.
  * Fix architecture detection logic.
  * Fix from upstream for another sparc64 related typo.

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 26 Oct 2016 03:31:54 -0700

seqan2 (2.3.0~1.20161019~af07bc1+dfsg-3) experimental; urgency=medium

  * Fix recursive variable expansion error.

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 24 Oct 2016 07:54:44 -0700

seqan2 (2.3.0~1.20161019~af07bc1+dfsg-2) experimental; urgency=medium

  * Fix typo from upstream's patch.
  * Work around GNU Hurd TANDEM problem
  * Skip armel
  * Test -O1 for mips[el] 
  * Test turning off parallel builds for armhf, mips, kfreebsd-*

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Thu, 20 Oct 2016 04:48:11 -0700

seqan2 (2.3.0~0.201610100~af07bc1+dfsg+1) experimental; urgency=medium

  * Second experimental build to test fix for #840030. Source from
    https://github.com/seqan/seqan/pull/1887/commits/af07bc19087e662117b70d733e963a1611aa9b9a

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Thu, 20 Oct 2016 02:06:15 -0700

seqan2 (2.3.0~0.20161011~73a5aaf+dfsg-1) experimental; urgency=low

  * Experimental build to test fix for #840030

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 11 Oct 2016 07:08:05 -0700

seqan2 (2.2.0+dfsg-6) UNRELEASED; urgency=medium

  * Drop Soeren Sonnenburg from Uploaders

 -- Andreas Tille <tille@debian.org>  Sat, 03 Dec 2016 08:08:51 +0100

seqan2 (2.2.0+dfsg-5) unstable; urgency=medium

  * Fix build issue with boost 1.62 (Thanks for the patch to Graham Inggs
    <ginggs@debian.org>)
    Closes: #846617
  * debhelper 10
  * d/watch: version=4

 -- Andreas Tille <tille@debian.org>  Fri, 02 Dec 2016 19:01:10 +0100

=== debian/control ===
Source: seqan2
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Michael R. Crusoe <michael.crusoe@gmail.com>,
           Kevin Murray <spam@kdmurray.id.au>
Section: science
Priority: optional
Build-Depends: debhelper (>= 10),
               cmake,
               zlib1g-dev,
               libbz2-dev,
               libbam-dev,
               libboost-dev,
               dh-exec,
               help2man,
               python,
               python-jinja2,
               python-sphinx,
               python-nose,
               default-jdk,
               dh-linktree
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/seqan2.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/seqan2.git
Homepage: http://www.seqan.de/

Package: seqan-apps
Architecture: any-amd64 arm64 armhf any-i386 mips64el powerpc ppc64el s390x alpha hppa m68k powerpcspe ppc64 sh4 sparc64 x32
# armel, not until std::future works https://gcc.gnu.org/bugzilla/show_bug.cgi?id=64735
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: C++ library for the analysis of biological sequences
 SeqAn is a C++ template library of efficient algorithms and data
 structures for the analysis of sequences with the focus on
 biological data. This library applies a unique generic design that
 guarantees high performance, generality, extensibility, and
 integration with other libraries. SeqAn is easy to use and
 simplifies the development of new software tools with a minimal loss
 of performance. This package contains the applications dfi, pair_align,
 micro_razers, seqan_tcoffee, seqcons, razers and tree_recon.

Package: libseqan2-dev
Architecture: all
Section: libdevel
Depends: ${misc:Depends}
Conflicts: seqan-dev
Description: C++ library for the analysis of biological sequences (development)
 SeqAn is a C++ template library of efficient algorithms and data
 structures for the analysis of sequences with the focus on
 biological data. This library applies a unique generic design that
 guarantees high performance, generality, extensibility, and
 integration with other libraries. SeqAn is easy to use and
 simplifies the development of new software tools with a minimal loss
 of performance.
 .
 This package contains the developer files.

#Package: seqan2-doc
#Architecture: all
#Section: doc
#Depends: ${misc:Depends},
#         libjs-bootstrap,
#         libjs-prettify,
#         libjs-jquery
#Description: C++ library for the analysis of biological sequences (documentation)
# SeqAn is a C++ template library of efficient algorithms and data
# structures for the analysis of sequences with the focus on
# biological data. This library applies a unique generic design that
# guarantees high performance, generality, extensibility, and
# integration with other libraries. SeqAn is easy to use and
# simplifies the development of new software tools with a minimal loss
# of performance. This package contains the applications dfi, pair_align,
# micro_razers, seqan_tcoffee, seqcons, razers and tree_recon.
# .
# This package contains the documentation and examples.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
UPSTREAM_VERSION = $(shell dpkg-parsechangelog -SVersion | egrep -o '^[0-9.]+')
export HOME=$(shell echo $$PWD"/fakehome")

# import hardening, adding CPPFLAGS to CFLAGS, in case dh doesn't
# See https://wiki.debian.org/Hardening#Notes_for_packages_using_CMake
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS) -O3
CXXFLAGS+=$(CPPFLAGS) -O3

# Droping -fstack-protector flag helps **drastically** reducing memory consumption when building the package!!!!
# export CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS | sed 's/-fstack-protector *//')  ## don't do this, it simply triggers #759978
# export DEB_BUILD_MAINT_OPTIONS = hardening=-stackprotector
# alternatively: export DEB_CXXFLAGS_STRIP='-fstack-protector'

DEB_HOST_ARCH       ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

DEB_BUILD_ARCH          ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
ifneq (,$(filter mips mipsel,$(DEB_BUILD_ARCH)))
    export CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS | sed 's/-O[1-9]//') -O1 -mxgot
endif
# Disable parallel building on some archs to save memory
ifneq (,$(filter amd64 arm64 armhf mips kfreebsd%,$(DEB_BUILD_ARCH)))
    $(info $$DEB_BUILD_OPTIONS was [${DEB_BUILD_OPTIONS}])
    TDBO := $(DEB_BUILD_OPTIONS)
    export DEB_BUILD_OPTIONS=parallel=1,$(filter $(TDBO), parallel)
endif
$(info $$DEB_BUILD_OPTIONS is [${DEB_BUILD_OPTIONS}])

# Try to save memory on kfreebsd-*
ifneq (,$(filter kfreebsd%,$(DEB_BUILD_ARCH)))
	export CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS | sed 's/-O[1-9]//') -O1
endif

pkgapps=seqan-apps
pkgdev=libseqan2-dev

%:
	dh $@ --parallel

override_dh_auto_configure-arch:
	dh_auto_configure -- -DSEQAN_BUILD_SYSTEM=SEQAN_RELEASE_APPS -DSEQAN_STATIC_APPS=False  # skip the tests for now

override_dh_auto_configure-indep: ;

override_dh_auto_build-arch:
	dh_auto_build --arch
	#cd obj-$(DEB_BUILD_GNU_TYPE); make dox # FIXME: This does nothing and no *.html files will be created at all
	# This ends up in:
	# Could not import extension sphinxcontrib.bibtex (exception: No module named sphinxcontrib.bibtex)
	# Seems there is no sphinx module bibtex - thus deactivating creation of html manual
	# cd manual && make html

override_dh_auto_build-indep:
	sed -e "s#@CMAKE_INSTALL_PREFIX@#/usr#g" \
	    -e "s/@SEQAN_VERSION_STRING@/$(UPSTREAM_VERSION)/g" \
	    -e "s/@CMAKE_PROJECT_NAME@/seqan/g" \
	    util/pkgconfig/seqan.pc.in > seqan-2.pc

override_dh_install:
	dh_install
	# Delete additional LICENSE files
	find $(CURDIR)/debian/$(pkgapps) -type f -name LICENSE -delete || /bin/true
	if [ -d $(CURDIR)/debian/$(pkgdev) ] ; then \
	    find $(CURDIR)/debian/$(pkgdev) -type f -name LICENSE -delete ; \
	    find $(CURDIR)/debian/$(pkgdev) -type f -name "*.pyc" -delete ; \
	fi

override_dh_auto_clean:
	dh_auto_clean
	find . -type f -name "*.pyc" -delete
	if [ -d orig ] ; then \
	  for header in `find orig -name "*generated_forwards.h"` ; do \
	    mv $${header} `echo $$header | sed 's?orig/??'` ; \
	  done ; \
	fi
	rm -rf orig seqan-2.pc

override_dh_installman:
	dh_link
	$(CURDIR)/debian/generate_manpages
	#for bin in `ls $(CURDIR)/debian/$(pkgapps)/usr/lib/seqan/bin` ; do \
	#    if [ -x $(CURDIR)/debian/$(pkgapps)/usr/lib/seqan/bin/`basename $${bin}` ] ; then \
	#        ln -s ../lib/seqan/bin/`basename $${bin}` $(CURDIR)/debian/$(pkgapps)/usr/bin/`basename $${bin}` ; \
	#    fi ; \
	#    if echo $${bin} | grep -q '\.sh$$' ; then \
	#        ln -s ../lib/seqan/bin/$${bin} $(CURDIR)/debian/$(pkgapps)/usr/bin/`basename $${bin} .sh` ; \
	#    fi ; \
	#done
	# we generate only those manpages where binaries are linked to /usr/bin
	dh_installman

override_dh_link-arch:
	dh_link
	# Some binaries (eg. splazer) are not built in 32-bit architectures so
	# remove their (broken) symlinks.
	find $(CURDIR)/debian/$(pkgapps)/usr/bin -type l -xtype l -delete

override_dh_fixperms-indep:
	dh_fixperms
	for bin in `ls $(CURDIR)/debian/$(pkgapps)/usr/lib/seqan/bin/*.sh` ; do \
	    chmod +x $(CURDIR)/debian/$(pkgapps)/usr/lib/seqan/bin/`basename $${bin}` ; \
	done
	find $(CURDIR)/debian/$(pkgdev)/usr/share/cmake -type f -exec chmod -x {} \;

override_dh_auto_test:
# Run test suite only on powerfull architectures (amd64) at build time
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 kfreebsd-amd64))
	dh_auto_test || true
else
	echo "Do not run test suite when building on architecture $(DEB_HOST_ARCH)"
endif
